<!------------------------------------------------------------------------------
  - @copyright 2022 IDEALIGN Stanisław Gregor
  ----------------------------------------------------------------------------->

<template>
  <section class="error-message">
    <h2 class="error-message__heading">Oops!</h2>
    <p class="error-message__body" ref="body">
      <slot>{{ DEFAULT_ERROR_MESSAGE }}</slot>
    </p>
  </section>
</template>

<script lang="ts">
import { defineComponent } from 'vue';

export const DEFAULT_ERROR_MESSAGE: string = `I shouldn't be rendered! If I did, it probably means that you did something wrong (e.g. forgot to populate a slot).`;

export default defineComponent({
  name: 'ThrowError',
  data: () => ({ DEFAULT_ERROR_MESSAGE }),
  computed: {
    /**
     * The feedback message that is to be logged-out into the console.
     */
    errorMessage(): string {
      const bodyRef = this.$refs.body;

      if (!(bodyRef instanceof HTMLParagraphElement)) {
        return this.DEFAULT_ERROR_MESSAGE;
      }

      return bodyRef.textContent ?? this.DEFAULT_ERROR_MESSAGE;
    },
  },
  mounted(): void {
    throw new Error(this.errorMessage);
  },
});
</script>

<style scoped>
.error-message {
  background: rgba(255, 0, 0, 0.2);
  font-size: 1rem;
  padding: 1.5em;
}

.error-message__heading {
  font-size: 2em;
  margin-top: 0;
  margin-bottom: 0.5em;
}

.error-message__body {
  font-size: 1em;
  margin-bottom: 0;
}
</style>
